#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

const int knockSensor = 0; // piezo pin
int knockSensorValue = 0; // valoarea citita de senzor

const int buttonReset = 2; // Pin-ul pe care acctioneaza butonul ce va reseta string-ul

const int timePerLetter = 5000; // timpul dintre litere
int timeSpent = 0;

char string[25]; // string-ul in care se pastreaza mesajul decodificat
char codeLetter[6]; // litera scrisa in cod morse (cu '.' si '-')
int i = 0; // iterator pentru litera
int j = 0; // iterator pentru string
int afis = 0; // iterator folosit pentru a afisa

#define OLED_CLK 10
#define OLED_MOSI 9
#define OLED_RESET 13
#define OLED_DC 11

Adafruit_SSD1306 display(128, 64, 9, 10, 11, 13, 12);
  
void setup() {
  // put your setup code here, to run once:
  pinMode(buttonReset, INPUT);
  
  Serial.begin(9600);
  Serial.println("Start decoding:");

  if(!display.begin(SSD1306_SWITCHCAPVCC)) {
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }

  // Show initial display buffer contents on the screen --
  // the library initializes this with an Adafruit splash screen.
  display.display();
  delay(2000); // Pause for 2 seconds

  // Clear the buffer
  display.clearDisplay();

  display.setCursor(10, 10);
  display.setTextSize(2);      // Size 2:1 pixel scale
  display.setTextColor(SSD1306_WHITE); // Draw white text
  display.cp437(true);         // Use full 256 char 'Code Page 437' font
}

void show_str(void) {
  display.setTextSize(2);
  display.setCursor(10, 30);
  display.println(string);
  display.display();
}

void show_letter() {
  display.setTextSize(1);
  display.print(codeLetter);
  display.display();
}

// functie ce intoarce litera corespunzatoare unui cod
char decode(char letter[6]) {
  if(strcmp(letter,".-")==0)
    return 'A';
  
  if(strcmp(letter,"-...")==0)
    return 'B';

  if(strcmp(letter,"-.-.")==0)
    return 'C';

  if(strcmp(letter,"-..")==0)
    return 'D';

  if(strcmp(letter,".")==0)
    return 'E';

  if(strcmp(letter,"..-.")==0)
    return 'F';

  if(strcmp(letter,"--.")==0)
    return 'G';

  if(strcmp(letter,"....")==0)
    return 'H';

  if(strcmp(letter,"..")==0)
    return 'I';

  if(strcmp(letter,".---")==0)
    return 'J';

  if(strcmp(letter,"-.-")==0)
    return 'K';

  if(strcmp(letter,".-..")==0)
    return 'L';

  if(strcmp(letter,"--")==0)
    return 'M';

  if(strcmp(letter,"-.")==0)
    return 'N';

  if(strcmp(letter,"---")==0)
    return 'O';

  if(strcmp(letter,".--.")==0)
    return 'P';

  if(strcmp(letter,"--.-")==0)
    return 'Q';
  
  if(strcmp(letter,".-.")==0)
    return 'R';

  if(strcmp(letter,"...")==0)
    return 'S';

  if(strcmp(letter,"-")==0)
    return 'T';

  if(strcmp(letter,"..-")==0)
    return 'U';

  if(strcmp(letter,"...-")==0)
    return 'V';

  if(strcmp(letter,".--")==0)
    return 'W';

  if(strcmp(letter,"-..-")==0)
    return 'X';

  if(strcmp(letter,"-.--")==0)
    return 'Y';
  
  if(strcmp(letter,"--..")==0)
    return 'Z';

  if(strcmp(letter,"-----")==0)
    return '0';

  if(strcmp(letter,".----")==0)
    return '1';

  if(strcmp(letter,"..---")==0)
    return '2';

  if(strcmp(letter,"...--")==0)
    return '3';

  if(strcmp(letter,"....-")==0)
    return '4';

  if(strcmp(letter,".....")==0)
    return '5';

  if(strcmp(letter,"-....")==0)
    return '6';

  if(strcmp(letter,"--...")==0)
    return '7';

  if(strcmp(letter,"---..")==0)
    return '8';

  if(strcmp(letter,"----.")==0)
    return '9';
}

void loop() {
  // put your main code here, to run repeatedly:
  char c;

  //citesc valoare data de senzor
  knockSensorValue = analogRead(knockSensor);

  //verific valoarea data de buton
  if (digitalRead(buttonReset) == HIGH) {
    display.clearDisplay();
    display.setCursor(10,10);
    memset(string, 0, sizeof(string));
    j=0;
  }

  if (knockSensorValue > 10){
    afis = 0;
    timeSpent = 0;
    if (knockSensorValue > 20){
      c = '-';
    }
    else {
      c = '.';
    }
    codeLetter[i] = c;
    i++;
    delay(150);
  }
  else {
    if(timeSpent > timePerLetter) {
      //adaug litera in string
      if (i != 0){
        //copiez litera in string in forma ei normala
        string[j] = decode(codeLetter);
        j++;

        //resetez litera
        //Serial.println(codeLetter);
        show_letter();
        memset(codeLetter,0,sizeof(codeLetter));
        i=0;
      }
      else {
        //daca am doua lipsuri consecutive afisez sirul
        if (afis > 5 && j != 0) {
          afis = 0;
          //Serial.println(string);
          show_str();
        }
        afis++;
      }

      //reset time
      timeSpent=0;
    }
    timeSpent++;
  }
}
